#define _BSD_SOURCE
#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <errno.h>

#include "bb_ams.h"
#include "bb.h"
#include "bb_data.h"

#include "net-snmp/net-snmp-config.h"
#include "net-snmp/library/snmp_impl.h"
#include <net-snmp/net-snmp-config.h>
#include <net-snmp/output_api.h>
#include "net-snmp/library/tools.h"

int bb_init();
int doCodeDescriptor(unsigned int, unsigned int, unsigned char, unsigned char,
                     unsigned char, unsigned char, unsigned char, char *);

void BB_LOG_OS_BOOT()
{
    int rc;

    if (!bb_init() ) {
        return;
    }
        
   /* do Code Descriptor */
    if ((rc = doCodeDescriptor(s_ams_bb_handle,
                               s_ams_bb_class,
                               BB_CODE_AMS_OS_BOOT,
                               0,
                               BB_SEV_CHANGE,
                               BB_BINARY_DATA,
                               BB_VIS_CUSTOMER,
                               BB_CODE_AMS_OS_BOOT_STR)) != BLACKBOX_OK) {
        DEBUGMSGTL(("bb:bb_log_osboot","OS Boot  register descriptor failed %d\n", rc));
        return;
    }

    /* Let's go ahead and set the code for */
    if ((rc = bb_code_set(s_ams_bb_handle, BB_CODE_AMS_OS_BOOT)) 
                != BLACKBOX_OK) {
        DEBUGMSGTL(("bb:log", "OS Boot bb_code_set failed (%d)\n", rc));
        return;
    }

    // Log the record
    if ((rc = bb_log(s_ams_bb_handle, (const char*)0, 0)) != 
             BLACKBOX_OK) {
        DEBUGMSGTL(("bb:log", "OS Boot bb_log failed (%d)\n",rc));
    }

    DEBUGMSGTL(("bb:log", "OS Boot Logged record for code %d\n", 
                BB_CODE_AMS_OS_BOOT));
    return;
}

void BB_LOG_OS_SHUTDOWN()
{
    int rc;

    if (!bb_init() ) {
        return;
    }

   /* do Code Descriptor */
    if ((rc = doCodeDescriptor(s_ams_bb_handle,
                               s_ams_bb_class,
                               BB_CODE_AMS_OS_SHUTDOWN,
                               0,
                               BB_SEV_CHANGE,
                               BB_BINARY_DATA,
                               BB_VIS_CUSTOMER,
                               BB_CODE_AMS_OS_SHUTDOWN_STR)) != BLACKBOX_OK) {
        DEBUGMSGTL(("bb:bb_log_osboot","OS Boot  register descriptor failed %d\n", rc));
        return;
    }

    /* Let's go ahead and set the code for */
    if ((rc = bb_code_set(s_ams_bb_handle, BB_CODE_AMS_OS_SHUTDOWN)) 
                != BLACKBOX_OK) {
        DEBUGMSGTL(("bb:log", "OS Shutdown bb_code_set failed (%d)\n", rc));
        return;
    }

    // Log the record
    if ((rc = bb_log(s_ams_bb_handle, (const char*)0, 0)) != 
             BLACKBOX_OK) {
        DEBUGMSGTL(("bb:log", "OS Shutdown LogBlackboxData failed (%d)\n",rc));
    }

    DEBUGMSGTL(("bb:log", "OS Shutdown Logged record for code %d\n", 
                BB_CODE_AMS_OS_SHUTDOWN));
    return;

}


