#define _BSD_SOURCE
#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <errno.h>

#include "bb_ams.h"
#include "bb.h"
#include "bb_data.h"

#include "net-snmp/net-snmp-config.h"
#include "net-snmp/library/snmp_impl.h"
#include <net-snmp/net-snmp-config.h>
#include <net-snmp/output_api.h>

int doCodeDescriptor(unsigned int handle,
                     unsigned int class,
                     unsigned char code,
                     unsigned char field,
                     unsigned char sev_type,
                     unsigned char format,
                     unsigned char vis,
                     char *descripstr)
{
    BLACKBOX_DESCRIPTOR_RECORD toc;
    int rc;

    memset(&toc, 0, sizeof(BLACKBOX_DESCRIPTOR_RECORD));
    toc.flags = BB_FLAGS_DESCRIPTOR | BB_FLAGS_DESC_CODE;
    toc.classs = class;
    toc.code = code;
    toc.field = 0;
    toc.severity_type = sev_type;
    toc.format = format;
    toc.visibility = vis;
    strcpy(&toc.desc[0], descripstr);
    if ((rc = bb_descriptor_code(s_ams_bb_handle,
                    sizeof(BLACKBOX_DESCRIPTOR_RECORD), &toc)) != BLACKBOX_OK) {
        DEBUGMSGTL(("bb:log","Host Name register descriptor failed %d\n", rc));
    }
    return rc;
}

