/*
 * Note: this file originally auto-generated by mib2c using
 *  $
 */

#include <net-snmp/net-snmp-config.h>
#include <net-snmp/net-snmp-includes.h>
#include <net-snmp/agent/net-snmp-agent-includes.h>
#include <net-snmp/agent/table_container.h>
#include <net-snmp/agent/agent_index.h>
#include "cpqHoFwVerTable.h"




static void     _cache_free(netsnmp_cache * cache, void *magic);
static int      _cache_load(netsnmp_cache * cache, void *vmagic);

const oid       cpqHoFwVerTable_oid[] = 
              { 1, 3, 6, 1, 4, 1, 232, 11, 2, 14, 1 };
const size_t    cpqHoFwVerTable_oid_len = OID_LENGTH(cpqHoFwVerTable_oid);
int   FWidx = 50;

/** Initializes the cpqHoFwVerTable module */
void
init_cpqHoFwVerTable(void)
{
    /*
     * here we initialize all the tables we're planning on supporting 
     */
    initialize_table_cpqHoFwVerTable();
}

/** Initialize the cpqHoFwVerTable table by defining its contents and how it's structured */
void
initialize_table_cpqHoFwVerTable(void)
{
    netsnmp_handler_registration *reg = NULL;
    netsnmp_mib_handler *handler = NULL;
    netsnmp_container *container = NULL;
    netsnmp_table_registration_info *table_info = NULL;
    netsnmp_cache  *cache = NULL;

    DEBUGMSGTL(("cpqHoFwVerTable:init",
                "initializing table cpqHoFwVerTable\n"));

    reg =
        netsnmp_create_handler_registration("cpqHoFwVerTable",
                                            cpqHoFwVerTable_handler,
                                            cpqHoFwVerTable_oid,
                                            cpqHoFwVerTable_oid_len,
                                            HANDLER_CAN_RONLY);
    if (NULL == reg) {
        snmp_log(LOG_ERR,
                 "error creating handler registration for cpqHoFwVerTable\n");
        goto bail;
    }

    container = netsnmp_container_find("cpqHoFwVerTable:table_container");
    if (NULL == container) {
        snmp_log(LOG_ERR, "error creating container for cpqHoFwVerTable\n");
        goto bail;
    }
    container->container_name = strdup("cpqHoFwVerTable container");

    table_info = SNMP_MALLOC_TYPEDEF(netsnmp_table_registration_info);
    if (NULL == table_info) {
        snmp_log(LOG_ERR,
                 "error allocating table registration for cpqHoFwVerTable\n");
        goto bail;
    }

    netsnmp_table_helper_add_indexes(table_info, ASN_INTEGER,   /* index: cpqHoFwVerIndex */
                                     0);
    table_info->min_column = COLUMN_CPQHOFWVERINDEX;
    table_info->max_column = COLUMN_CPQHOFWVERUPDATEMETHOD;

    /*************************************************
     *
     * inject container_table helper
     */
    handler = netsnmp_container_table_handler_get(table_info, container,
                                                  TABLE_CONTAINER_KEY_NETSNMP_INDEX);
    if (NULL == handler) {
        snmp_log(LOG_ERR,
                 "error allocating table registration for cpqHoFwVerTable\n");
        goto bail;
    }
    if (SNMPERR_SUCCESS != netsnmp_inject_handler(reg, handler)) {
        snmp_log(LOG_ERR,
                 "error injecting container_table handler for cpqHoFwVerTable\n");
        goto bail;
    }
    handler = NULL;             /* reg has it, will reuse below */

    /*************************************************
     *
     * inject cache helper
     */
    cache = netsnmp_cache_create(240,    /* timeout in seconds */
                                 _cache_load, _cache_free,
                                 cpqHoFwVerTable_oid,
                                 cpqHoFwVerTable_oid_len);

    if (NULL == cache) {
        snmp_log(LOG_ERR, "error creating cache for cpqHoFwVerTable\n");
        goto bail;
    }
    cache->flags = NETSNMP_CACHE_DONT_FREE_EXPIRED |
                   NETSNMP_CACHE_DONT_AUTO_RELEASE |
                   NETSNMP_CACHE_DONT_FREE_BEFORE_LOAD |
                   NETSNMP_CACHE_DONT_INVALIDATE_ON_SET;

    cache->magic = container;

    handler = netsnmp_cache_handler_get(cache);
    if (NULL == handler) {
        snmp_log(LOG_ERR,
                 "error creating cache handler for cpqHoFwVerTable\n");
        goto bail;
    }

    if (SNMPERR_SUCCESS != netsnmp_inject_handler(reg, handler)) {
        snmp_log(LOG_ERR,
                 "error injecting cache handler for cpqHoFwVerTable\n");
        goto bail;
    }
    handler = NULL;             /* reg has it */

    /*
     * register the table
     */
    if (SNMPERR_SUCCESS != netsnmp_register_table(reg, table_info)) {
        snmp_log(LOG_ERR,
                 "error registering table handler for cpqHoFwVerTable\n");
        goto bail;
    }

    return;                     /* ok */

    /*
     * Some error occurred during registration. Clean up and bail.
     */
  bail:                        /* not ok */

    if (handler)
        netsnmp_handler_free(handler);

    if (cache)
        netsnmp_cache_free(cache);

    if (table_info)
        netsnmp_table_registration_info_free(table_info);

    if (container)
        CONTAINER_FREE(container);

    if (reg)
        netsnmp_handler_registration_free(reg);
}

/** create a new row in the table */
cpqHoFwVerTable_entry *
cpqHoFwVerTable_createEntry(netsnmp_container * container,
                           oid cpqHoFwVerIndex)
{
    cpqHoFwVerTable_entry *entry;

    entry = SNMP_MALLOC_TYPEDEF(cpqHoFwVerTable_entry);
    if (!entry)
        return NULL;

    entry->cpqHoFwVerIndex = cpqHoFwVerIndex;
    entry->oid_index.len = 1;
    entry->oid_index.oids = (oid *) &entry->cpqHoFwVerIndex;
    return entry;
}

/** remove a row from the table */
void
cpqHoFwVerTable_removeEntry(netsnmp_container * container,
                           cpqHoFwVerTable_entry * entry)
{

    if (!entry)
        return;                 /* Nothing to remove */
    CONTAINER_REMOVE(container, entry);
    if (entry)
        SNMP_FREE(entry);       /* XXX - release any other internal resources */
}

/** remove a row from the table */
void
cpqHoFwVerTable_freeEntry(cpqHoFwVerTable_entry * entry)
{

    if (!entry)
        return;                 /* Nothing to remove */
    SNMP_FREE(entry);           /* XXX - release any other internal resources */
}

/** handles requests for the cpqHoFwVerTable table */
int
cpqHoFwVerTable_handler(netsnmp_mib_handler *handler,
                        netsnmp_handler_registration *reginfo,
                        netsnmp_agent_request_info *reqinfo,
                        netsnmp_request_info *requests)
{

    netsnmp_request_info *request;
    netsnmp_table_request_info *table_info;
    cpqHoFwVerTable_entry *table_entry;

    DEBUGMSGTL(("cpqHoFwVerTable:handler", "Processing request (%d)\n",
                reqinfo->mode));

    switch (reqinfo->mode) {
        /*
         * Read-support (also covers GetNext requests)
         */
    case MODE_GET:
        for (request = requests; request; request = request->next) {
           if (request->processed)
                continue;

            table_entry = (cpqHoFwVerTable_entry *)
                netsnmp_container_table_extract_context(request);
            table_info = netsnmp_extract_table_info(request);

           if ((NULL == table_entry) || (NULL == table_info)) {
                snmp_log(LOG_ERR,
                         "Table entry or info for cpqHoFwVerTable is NULL\n");
                snmp_set_var_typed_value(request->requestvb,
                                         SNMP_ERR_GENERR, NULL, 0);
                continue;
            }

            switch (table_info->colnum) {
            case COLUMN_CPQHOFWVERINDEX:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }

                snmp_set_var_typed_integer(request->requestvb, ASN_INTEGER,
                                           table_entry->cpqHoFwVerIndex);
                break;
            case COLUMN_CPQHOFWVERCATEGORY:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_integer(request->requestvb, ASN_INTEGER,
                                           table_entry->
                                           cpqHoFwVerCategory);
                break;
            case COLUMN_CPQHOFWVERDEVICETYPE:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_integer(request->requestvb, ASN_INTEGER,
                                           table_entry->
                                           cpqHoFwVerDeviceType);
                break;
            case COLUMN_CPQHOFWVERDISPLAYNAME:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_value(request->requestvb, ASN_OCTET_STR,
                                         table_entry->
                                         cpqHoFwVerDisplayName,
                                         table_entry->
                                         cpqHoFwVerDisplayName_len);
                break;
            case COLUMN_CPQHOFWVERVERSION:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_value(request->requestvb, ASN_OCTET_STR,
                                         table_entry->cpqHoFwVerVersion,
                                         table_entry->
                                         cpqHoFwVerVersion_len);
                break;
            case COLUMN_CPQHOFWVERLOCATION:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_value(request->requestvb, ASN_OCTET_STR,
                                         table_entry->cpqHoFwVerLocation,
                                         table_entry->
                                         cpqHoFwVerLocation_len);
                break;
            case COLUMN_CPQHOFWVERXMLSTRING:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_value(request->requestvb, ASN_OCTET_STR,
                                         table_entry->cpqHoFwVerXmlString,
                                         table_entry->
                                         cpqHoFwVerXmlString_len);
                break;
            case COLUMN_CPQHOFWVERKEYSTRING:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_value(request->requestvb, ASN_OCTET_STR,
                                         table_entry->cpqHoFwVerKeyString,
                                         table_entry->
                                         cpqHoFwVerKeyString_len);
                break;
            case COLUMN_CPQHOFWVERUPDATEMETHOD:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_integer(request->requestvb, ASN_INTEGER,
                                           table_entry->
                                           cpqHoFwVerUpdateMethod);
                break;
            default:
                netsnmp_set_request_error(reqinfo, request,
                                          SNMP_NOSUCHOBJECT);
                break;
            }
        }
        break;

    }
    return SNMP_ERR_NOERROR;
}

/**
 * @internal
 */
static int
_cache_load(netsnmp_cache * cache, void *vmagic)
{
    netsnmp_container *container;

    if ((NULL == cache) || (NULL == cache->magic)) {
        snmp_log(LOG_ERR, "invalid cache for cpqHoFwVerTable_cache_load\n");
        return -1;
    }
    container = (netsnmp_container *) cache->magic;

    /** should only be called for an invalid or expired cache */
    netsnmp_assert((0 == cache->valid) || (1 == cache->expired));

    /*
     * load cache here (or call function to do it)
     */
    cache->valid = 1;
    cache->expired = 0;

    return 0;
}                               /* _cache_load */

/**
 * @internal
 */
/** remove a row from the table */
static void
cpqHoFwVerTable_freeEntry_cb(cpqHoFwVerTable_entry * entry, void *magic)
{

    cpqHoFwVerTable_freeEntry(entry);
}

/**
  * @internal
  */
static void
_cache_free(netsnmp_cache * cache, void *magic)
{
    netsnmp_container *container;


    if ((NULL == cache) || (NULL == cache->magic)) {
        snmp_log(LOG_ERR, "invalid cache in cpqHoFwVerTable_cache_free\n");
        return;
    }
    container = (netsnmp_container *) cache->magic;

    /*
     * empty (but don't free) cache here
     */
    CONTAINER_CLEAR(container,
                    (netsnmp_container_obj_func *)
                    cpqHoFwVerTable_freeEntry_cb, NULL);
}                               /* _cache_free */

