/*
 * Note: this file originally auto-generated by mib2c using
 *  : mib2c.table_data.conf 19302 2010-08-13 12:19:42Z dts12 $
 */

#include <net-snmp/net-snmp-config.h>
#include <net-snmp/net-snmp-includes.h>
#include <net-snmp/agent/net-snmp-agent-includes.h>
#include <net-snmp/agent/table_container.h>
#include "cpqHoSWRunningTable.h"

extern int cpqhost_arch_swrun_container_load(netsnmp_container*);
static void     _cache_free(netsnmp_cache * cache, void *magic);
static int      _cache_load(netsnmp_cache * cache, void *vmagic);

/** Initializes the cpqHoSWRunningTable module */
void
init_cpqHoSWRunningTable(void)
{
    /*
     * here we initialize all the tables we're planning on supporting 
     */
    initialize_table_cpqHoSWRunningTable();
}


/** Initialize the cpqHoSWRunningTable table by defining its contents and how it's structured */
void
initialize_table_cpqHoSWRunningTable(void)
{
    const oid       cpqHoSWRunningTable_oid[] =
        { 1, 3, 6, 1, 4, 1, 232, 11, 2, 6, 1 };
    const size_t    cpqHoSWRunningTable_oid_len =
        OID_LENGTH(cpqHoSWRunningTable_oid);
    netsnmp_handler_registration *reg = NULL;
    netsnmp_mib_handler *handler = NULL;
    netsnmp_container *container = NULL;
    netsnmp_table_registration_info *table_info = NULL;
    netsnmp_cache  *cache = NULL;

    DEBUGMSGTL(("cpqHoSWRunningTable:init",
                "initializing table cpqHoSWRunningTable\n"));

    reg =
        netsnmp_create_handler_registration("cpqHoSWRunningTable",
                                            cpqHoSWRunningTable_handler,
                                            cpqHoSWRunningTable_oid,
                                            cpqHoSWRunningTable_oid_len,
                                            HANDLER_CAN_RONLY);
    if (NULL == reg) {
        snmp_log(LOG_ERR,
                 "error creating handler registration for cpqHoSWRunningTable\n");
        goto bail;
    }

    container =
        netsnmp_container_find("cpqHoSWRunningTable:table_container");
    if (NULL == container) {
        snmp_log(LOG_ERR,
                 "error creating container for cpqHoSWRunningTable\n");
        goto bail;
    }
    container->container_name = strdup("cpqHoSWRunningTable container");

    table_info = SNMP_MALLOC_TYPEDEF(netsnmp_table_registration_info);
    if (NULL == table_info) {
        snmp_log(LOG_ERR,
                 "error allocating table registration for cpqHoSWRunningTable\n");
        goto bail;
    }

    netsnmp_table_helper_add_indexes(table_info, ASN_INTEGER,   /* index: cpqHoSWRunningIndex */
                                     0);

    table_info->min_column = COLUMN_CPQHOSWRUNNINGINDEX;
    table_info->max_column = COLUMN_CPQHOSWRUNNINGREDUNDANCYMODE;

    /*************************************************
     *
     * inject container_table helper
     */
    handler = netsnmp_container_table_handler_get(table_info, container,
                                                  TABLE_CONTAINER_KEY_NETSNMP_INDEX);
    if (NULL == handler) {
        snmp_log(LOG_ERR,
                 "error allocating table registration for cpqHoSWRunningTable\n");
        goto bail;
    }
    if (SNMPERR_SUCCESS != netsnmp_inject_handler(reg, handler)) {
        snmp_log(LOG_ERR,
                 "error injecting container_table handler for cpqHoSWRunningTable\n");
        goto bail;
    }
    handler = NULL;             /* reg has it, will reuse below */

    /*************************************************
     *
     * inject cache helper
     */
    cache = netsnmp_cache_create(240,    /* timeout in seconds */
                                 _cache_load, _cache_free,
                                 cpqHoSWRunningTable_oid,
                                 cpqHoSWRunningTable_oid_len);

    if (NULL == cache) {
        snmp_log(LOG_ERR, "error creating cache for cpqHoSWRunningTable\n");
        goto bail;
    }
    cache->flags = NETSNMP_CACHE_DONT_INVALIDATE_ON_SET;
    cache->magic = container;

    handler = netsnmp_cache_handler_get(cache);
    if (NULL == handler) {
        snmp_log(LOG_ERR,
                 "error creating cache handler for cpqHoSWRunningTable\n");
        goto bail;
    }

    if (SNMPERR_SUCCESS != netsnmp_inject_handler(reg, handler)) {
        snmp_log(LOG_ERR,
                 "error injecting cache handler for cpqHoSWRunningTable\n");
        goto bail;
    }
    handler = NULL;             /* reg has it */

    /*
     * register the table
     */
    if (SNMPERR_SUCCESS != netsnmp_register_table(reg, table_info)) {
        snmp_log(LOG_ERR,
                 "error registering table handler for cpqHoSWRunningTable\n");
        goto bail;
    }

    return;                     /* ok */

    /*
     * Some error occurred during registration. Clean up and bail.
     */
  bail:                        /* not ok */

    if (handler)
        netsnmp_handler_free(handler);

    if (cache)
        netsnmp_cache_free(cache);

    if (table_info)
        netsnmp_table_registration_info_free(table_info);

    if (container)
        CONTAINER_FREE(container);

    if (reg)
        netsnmp_handler_registration_free(reg);


    /*
     * Initialise the contents of the table here 
     */
}

/*
 * create a new row in the table 
 */
cpqHoSWRunningTable_entry *
cpqHoSWRunningTable_createEntry(netsnmp_container * container,
                                oid cpqHoSWRunningIndex)
{
    cpqHoSWRunningTable_entry *entry;

    entry = SNMP_MALLOC_TYPEDEF(cpqHoSWRunningTable_entry);
    if (!entry)
        return NULL;

    entry->cpqHoSWRunningIndex =cpqHoSWRunningIndex;
    entry->oid_index.len = 1;
    entry->oid_index.oids = (oid *) &entry->cpqHoSWRunningIndex;
    return entry;

}

#ifdef NOT_NEEDED
/*
 * remove a row from the table 
 */
void
cpqHoSWRunningTable_removeEntry(netsnmp_container * container,
				cpqHoSWRunningTable_entry *entry)
{

    if (!entry)
        return;                 /* Nothing to remove */
    CONTAINER_REMOVE(container, entry);
    if (entry)
        SNMP_FREE(entry);       /* XXX - release any other internal resources */
}
#endif

/** free a row from the table */
void
cpqHoSWRunningTable_freeEntry(cpqHoSWRunningTable_entry * entry)
{

    if (!entry)
        return;                 /* Nothing to remove */
    SNMP_FREE(entry);           /* XXX - release any other internal resources */
}

/** handles requests for the cpqHoSWRunningTable table */
int
cpqHoSWRunningTable_handler(netsnmp_mib_handler *handler,
                            netsnmp_handler_registration *reginfo,
                            netsnmp_agent_request_info *reqinfo,
                            netsnmp_request_info *requests)
{

    netsnmp_request_info *request;
    netsnmp_table_request_info *table_info;
    cpqHoSWRunningTable_entry *table_entry;

    DEBUGMSGTL(("cpqHoSWRunningTable:handler", "Processing request (%d)\n",
                reqinfo->mode));

    switch (reqinfo->mode) {
        /*
         * Read-support (also covers GetNext requests)
         */
    case MODE_GET:
        for (request = requests; request; request = request->next) {
            if (request->processed)
                continue;
            table_entry = (cpqHoSWRunningTable_entry *)
                 netsnmp_container_table_extract_context(request);
            table_info = netsnmp_extract_table_info(request);
            if ((NULL == table_entry) || (NULL == table_info)) {
                snmp_log(LOG_ERR,
                         "could not extract table entry or info for cpqHoSWRunningTable\n");
                snmp_set_var_typed_value(request->requestvb,
                                         SNMP_ERR_GENERR, NULL, 0);
                continue;
            }

            switch (table_info->colnum) {
            case COLUMN_CPQHOSWRUNNINGINDEX:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_integer(request->requestvb, ASN_INTEGER,
                                           table_entry->
                                           cpqHoSWRunningIndex);
                break;
            case COLUMN_CPQHOSWRUNNINGNAME:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_value(request->requestvb, ASN_OCTET_STR,
                                         table_entry->cpqHoSWRunningName,
                                         table_entry->
                                         cpqHoSWRunningName_len);
                break;
            case COLUMN_CPQHOSWRUNNINGDESC:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                if ( table_entry->cpqHoSWRunningDesc_len == 0) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_value(request->requestvb, ASN_OCTET_STR,
                                         table_entry->cpqHoSWRunningDesc,
                                         table_entry->
                                         cpqHoSWRunningDesc_len);
                break;
            case COLUMN_CPQHOSWRUNNINGVERSION:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                if ( table_entry->cpqHoSWRunningVersion_len == 0) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_value(request->requestvb, ASN_OCTET_STR,
                                         table_entry->
                                         cpqHoSWRunningVersion,
                                         table_entry->
                                         cpqHoSWRunningVersion_len);
                break;
            case COLUMN_CPQHOSWRUNNINGDATE:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                if ( table_entry->cpqHoSWRunningDate_len == 0) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_value(request->requestvb, ASN_OCTET_STR,
                                         table_entry->cpqHoSWRunningDate,
                                         table_entry->
                                         cpqHoSWRunningDate_len);
                break;
            case COLUMN_CPQHOSWRUNNINGMONITOR:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_integer(request->requestvb, ASN_INTEGER,
                                           table_entry->
                                           cpqHoSWRunningMonitor);
                break;
            case COLUMN_CPQHOSWRUNNINGSTATE:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_integer(request->requestvb, ASN_INTEGER,
                                           table_entry->
                                           cpqHoSWRunningState);
                break;
            case COLUMN_CPQHOSWRUNNINGCOUNT:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_integer(request->requestvb, ASN_INTEGER,
                                           table_entry->
                                           cpqHoSWRunningCount);
                break;
            case COLUMN_CPQHOSWRUNNINGCOUNTMIN:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_integer(request->requestvb, ASN_INTEGER,
                                           table_entry->
                                           cpqHoSWRunningCountMin);
                break;
            case COLUMN_CPQHOSWRUNNINGCOUNTMAX:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_integer(request->requestvb, ASN_INTEGER,
                                           table_entry->
                                           cpqHoSWRunningCountMax);
                break;
            case COLUMN_CPQHOSWRUNNINGEVENTTIME:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                if ( table_entry->cpqHoSWRunningEventTime_len == 0) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_value(request->requestvb, ASN_OCTET_STR,
                                         table_entry->
                                         cpqHoSWRunningEventTime,
                                         table_entry->
                                         cpqHoSWRunningEventTime_len);
                break;
            case COLUMN_CPQHOSWRUNNINGSTATUS:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_integer(request->requestvb, ASN_INTEGER,
                                           table_entry->
                                           cpqHoSWRunningStatus);
                break;
            case COLUMN_CPQHOSWRUNNINGCONFIGSTATUS:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_integer(request->requestvb, ASN_INTEGER,
                                           table_entry->
                                           cpqHoSWRunningConfigStatus);
                break;
            case COLUMN_CPQHOSWRUNNINGIDENTIFIER:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                if ( table_entry->cpqHoSWRunningIdentifier_len == 0) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_value(request->requestvb, ASN_OCTET_STR,
                                         table_entry->
                                         cpqHoSWRunningIdentifier,
                                         table_entry->
                                         cpqHoSWRunningIdentifier_len);
                break;
            case COLUMN_CPQHOSWRUNNINGREDUNDANCYMODE:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_integer(request->requestvb, ASN_INTEGER,
                                           table_entry->
                                           cpqHoSWRunningRedundancyMode);
                break;
            default:
                netsnmp_set_request_error(reqinfo, request,
                                          SNMP_NOSUCHOBJECT);
                break;
            }
        }
        break;
    }
    return SNMP_ERR_NOERROR;
}

/**
 * @internal
 */
static int
_cache_load(netsnmp_cache * cache, void *vmagic)
{
    netsnmp_container *container;

    DEBUGMSGTL(("internal:cpqHoSWRunningTable:_cache_load", "called\n"));

    if ((NULL == cache) || (NULL == cache->magic)) {
        snmp_log(LOG_ERR,
                 "invalid cache for cpqHoSWRunningTable_cache_load\n");
        return -1;
    }
    container = (netsnmp_container *) cache->magic;

    /** should only be called for an invalid or expired cache */
    netsnmp_assert((0 == cache->valid) || (1 == cache->expired));

    /*
     * load cache here (or call function to do it)
     */
    cpqhost_arch_swrun_container_load(container);
    return 0;
}                               /* _cache_load */

/**
 * @Internal
 */
/** remove a row from the table */
static void
cpqHoSWRunningTable_freeEntry_cb(cpqHoSWRunningTable_entry * entry,
                                void *magic)
{

    cpqHoSWRunningTable_freeEntry(entry);
}

/**
 * @internal
 */
static void
_cache_free(netsnmp_cache * cache, void *magic)
{
    netsnmp_container *container;

    DEBUGMSGTL(("internal:cpqHoSWRunningTable:_cache_free", "called\n"));

    if ((NULL == cache) || (NULL == cache->magic)) {
        snmp_log(LOG_ERR,
                 "invalid cache in cpqHoSWRunningTable_cache_free\n");
        return;
    }
    container = (netsnmp_container *) cache->magic;

    /*
     * empty (but don't free) cache here
     */
    CONTAINER_CLEAR(container,
                    (netsnmp_container_obj_func *)
                    cpqHoSWRunningTable_freeEntry_cb, NULL);
}                               /* _cache_free */

