/*
 * Note: this file originally auto-generated by mib2c using
 *        : mib2c.old-api.conf 14476 2006-04-18 17:36:51Z hardaker $
 */

#include <net-snmp/net-snmp-config.h>
#include <net-snmp/net-snmp-includes.h>
#include <net-snmp/agent/net-snmp-agent-includes.h>
#include "cpqIde.h"
#include "cpqIdeControllerTable.h"
#include "cpqIdeAtaDiskTable.h"
#include "hpHelper.h"

/*
 * cpqIdeMib_oid:
 *   this is the top level oid that we want to register under.  This
 *   is essentially a prefix, with the suffix appearing in the
 *   variable below.
 */

oid             cpqIdeMib_oid[] = { 1, 3, 6, 1, 4, 1, 232, 14, 1 };
size_t          cpqIdeMib_oid_len = OID_LENGTH(cpqIdeMib_oid);


#define CPQIDEMIBREVMAJOR		1
#define CPQIDEMIBREVMINOR		2
#define CPQIDEMIBCONDITION		3

/** Initializes the cpqIde module */
void
init_cpqIde(void)
{

    DEBUGMSGTL(("cpqIde", "Initializing\n"));

    cpqHostMibStatusArray[CPQMIB].major = CPQMIBREVMAJOR;
    cpqHostMibStatusArray[CPQMIB].minor = CPQMIBREVMINOR;
    cpqHoMibHealthStatusArray[CPQMIBHEALTHINDEX] = MIB_CONDITION_OK;

    /*
     * register ourselves with the agent to handle our mib tree 
     */
    netsnmp_register_scalar_group(
        netsnmp_create_handler_registration("cpqIde", cpqIde_handler,
                             cpqIdeMib_oid, cpqIdeMib_oid_len,
                             HANDLER_CAN_RONLY),
                    CPQIDEMIBREVMAJOR, CPQIDEMIBCONDITION);

    init_cpqIdeControllerTable();
    init_cpqIdeAtaDiskTable();

    /*
     * place any other initialization junk you need here 
     */
    cpqHostMibStatusArray[CPQMIB].stat = MIB_STATUS_AVAILABLE;
    cpqHostMibStatusArray[CPQMIB].cond = MIB_CONDITION_OK;

}


int
cpqIde_handler(netsnmp_mib_handler          *handler,
               netsnmp_handler_registration *reginfo,
               netsnmp_agent_request_info   *reqinfo,
               netsnmp_request_info         *requests)
{
    long val = 0;

    switch (reqinfo->mode) {
    case MODE_GET:
        switch (requests->requestvb->name[ reginfo->rootoid_len - 2 ]) {
            case CPQIDEMIBREVMAJOR:
                val = CPQMIBREVMAJOR;
                break;
            case CPQIDEMIBREVMINOR:
                val = CPQMIBREVMINOR;
                break;
            case CPQIDEMIBCONDITION:
                val = cpqHoMibHealthStatusArray[CPQMIBHEALTHINDEX];
                break;
            default:
                /*
                * An unsupported/unreadable column (if applicable)
                */
                snmp_log(LOG_ERR, "unknown object (%lu) in cpqIde_handler\n",
                     requests->requestvb->name[ reginfo->rootoid_len - 2 ]);
                netsnmp_set_request_error( reqinfo, requests,
                                            SNMP_NOSUCHOBJECT );
                return SNMP_ERR_NOERROR;
        }
        snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER,
                                 (u_char *)&val, sizeof(val));
        break;

    default:
        snmp_log(LOG_ERR, "unknown mode (%d) in cpqIde_handlery\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;

}

