/*
 * Note: this file originally auto-generated by mib2c using
 *  : mib2c.container.conf 17798 2009-10-27 06:44:54Z magfr $
 */

#include <net-snmp/net-snmp-config.h>
#include <net-snmp/net-snmp-includes.h>
#include <net-snmp/agent/net-snmp-agent-includes.h>
#include <net-snmp/agent/net-snmp-agent-includes.h>
#include <net-snmp/agent/table_container.h>
#include "cpqSePciFunctTable.h"

static void     _cache_free(netsnmp_cache * cache, void *magic);
static int      _cache_load(netsnmp_cache * cache, void *vmagic);
extern void    netsnmp_arch_pci_init();

/** Initializes the cpqSePciFunctTable module */
void
init_cpqSePciFunctTable(void)
{
    /*
     * here we initialize all the tables we're planning on supporting 
     */
    initialize_table_cpqSePciFunctTable();
}

/** Initialize the cpqSePciFunctTable table by defining its contents and how it's structured */
void
initialize_table_cpqSePciFunctTable(void)
{
    const oid       cpqSePciFunctTable_oid[] =
        { 1, 3, 6, 1, 4, 1, 232, 1, 2, 13, 2 };
    const size_t    cpqSePciFunctTable_oid_len =
        OID_LENGTH(cpqSePciFunctTable_oid);
    netsnmp_handler_registration *reg = NULL;
    netsnmp_mib_handler *handler = NULL;
    netsnmp_container *container = NULL;
    netsnmp_table_registration_info *table_info = NULL;
    netsnmp_cache  *cache = NULL;

    DEBUGMSGTL(("cpqSePciFunctTable:init",
                "initializing table cpqSePciFunctTable\n"));

    reg =
        netsnmp_create_handler_registration("cpqSePciFunctTable",
                                            cpqSePciFunctTable_handler,
                                            cpqSePciFunctTable_oid,
                                            cpqSePciFunctTable_oid_len,
                                            HANDLER_CAN_RONLY);
    if (NULL == reg) {
        snmp_log(LOG_ERR,
                 "error creating handler registration for cpqSePciFunctTable\n");
        goto bail;
    }

    container =
        netsnmp_container_find("cpqSePciFunctTable:table_container");
    if (NULL == container) {
        snmp_log(LOG_ERR,
                 "error creating container for cpqSePciFunctTable\n");
        goto bail;
    }
    container->container_name = strdup("PciFuncTable container");

    table_info = SNMP_MALLOC_TYPEDEF(netsnmp_table_registration_info);
    if (NULL == table_info) {
        snmp_log(LOG_ERR,
                 "error allocating table registration for cpqSePciFunctTable\n");
        goto bail;
    }
    netsnmp_table_helper_add_indexes(table_info, ASN_INTEGER,   /* index: cpqSePciFunctBusNumberIndex */
                                     ASN_INTEGER,       /* index: cpqSePciFunctDeviceNumberIndex */
                                     ASN_INTEGER,       /* index: cpqSePciFunctIndex */
                                     0);
    table_info->min_column = COLUMN_CPQSEPCIFUNCTBUSNUMBERINDEX;
    table_info->max_column = COLUMN_CPQSEPCIFUNCTDEVSTATUS;

    /*************************************************
     *
     * inject container_table helper
     */
    handler = netsnmp_container_table_handler_get(table_info, container,
                                                  TABLE_CONTAINER_KEY_NETSNMP_INDEX);
    if (NULL == handler) {
        snmp_log(LOG_ERR,
                 "error allocating table registration for cpqSePciFunctTable\n");
        goto bail;
    }
    if (SNMPERR_SUCCESS != netsnmp_inject_handler(reg, handler)) {
        snmp_log(LOG_ERR,
                 "error injecting container_table handler for cpqSePciFunctTable\n");
        goto bail;
    }
    handler = NULL;             /* reg has it, will reuse below */

    /*************************************************
     *
     * inject cache helper
     */
    cache = netsnmp_cache_create(1200,    /* timeout in seconds */
                                 _cache_load, _cache_free,
                                 cpqSePciFunctTable_oid,
                                 cpqSePciFunctTable_oid_len);

    if (NULL == cache) {
        snmp_log(LOG_ERR, "error creating cache for cpqSePciFunctTable\n");
        goto bail;
    }
    cache->flags = NETSNMP_CACHE_DONT_INVALIDATE_ON_SET;
    cache->magic = container;

    handler = netsnmp_cache_handler_get(cache);
    if (NULL == handler) {
        snmp_log(LOG_ERR,
                 "error creating cache handler for cpqSePciFunctTable\n");
        goto bail;
    }

    if (SNMPERR_SUCCESS != netsnmp_inject_handler(reg, handler)) {
        snmp_log(LOG_ERR,
                 "error injecting cache handler for cpqSePciFunctTable\n");
        goto bail;
    }
    handler = NULL;             /* reg has it */

    /*
     * register the table
     */
    if (SNMPERR_SUCCESS != netsnmp_register_table(reg, table_info)) {
        snmp_log(LOG_ERR,
                 "error registering table handler for cpqSePciFunctTable\n");
        goto bail;
    }

    /*
     * Initialise the contents of the table here
     */
    netsnmp_arch_pci_init();
    return;                     /* ok */

    /*
     * Some error occurred during registration. Clean up and bail.
     */
  bail:                        /* not ok */

    if (handler)
        netsnmp_handler_free(handler);

    if (cache)
        netsnmp_cache_free(cache);

    if (table_info)
        netsnmp_table_registration_info_free(table_info);

    if (container)
        CONTAINER_FREE(container);

    if (reg)
        netsnmp_handler_registration_free(reg);
}

/** create a new row in the table */
cpqSePciFunctTable_entry *
cpqSePciFunctTable_createEntry(netsnmp_container * container,
                               oid cpqSePciFunctBusNumberIndex,
                               oid cpqSePciFunctDeviceNumberIndex,
                               oid cpqSePciFunctIndex)
{
    cpqSePciFunctTable_entry *entry;

    entry = SNMP_MALLOC_TYPEDEF(cpqSePciFunctTable_entry);
    if (!entry)
        return NULL;

    entry->cpqSePciFunctBusNumberIndex = cpqSePciFunctBusNumberIndex;
    entry->cpqSePciFunctDeviceNumberIndex = cpqSePciFunctDeviceNumberIndex;
    entry->cpqSePciFunctIndex = cpqSePciFunctIndex;
    entry->oid_index.len = 3;
    entry->oid_index.oids = (oid *) &entry->cpqSePciFunctBusNumberIndex;
    return entry;
}

/** remove a row from the table */
void
cpqSePciFunctTable_removeEntry(netsnmp_container * container,
                               cpqSePciFunctTable_entry * entry)
{

    if (!entry)
        return;                 /* Nothing to remove */
    CONTAINER_REMOVE(container, entry);
    if (entry)
        SNMP_FREE(entry);       /* XXX - release any other internal resources */
}

/** remove a row from the table */
void
cpqSePciFunctTable_freeEntry(cpqSePciFunctTable_entry * entry)
{

    if (!entry)
        return;                 /* Nothing to remove */
    SNMP_FREE(entry);           /* XXX - release any other internal resources */
}

/** handles requests for the cpqSePciFunctTable table */
int
cpqSePciFunctTable_handler(netsnmp_mib_handler *handler,
                           netsnmp_handler_registration *reginfo,
                           netsnmp_agent_request_info *reqinfo,
                           netsnmp_request_info *requests)
{

    netsnmp_request_info *request;
    netsnmp_table_request_info *table_info;
    cpqSePciFunctTable_entry *table_entry;

    DEBUGMSGTL(("cpqSePciFunctTable:handler", "Processing request (%d)\n",
                reqinfo->mode));

    switch (reqinfo->mode) {
        /*
         * Read-support (also covers GetNext requests)
         */
    case MODE_GET:
        for (request = requests; request; request = request->next) {
            if (request->processed)
                continue;
            table_entry = (cpqSePciFunctTable_entry *)
                netsnmp_container_table_extract_context(request);
            table_info = netsnmp_extract_table_info(request);
            if ((NULL == table_entry) || (NULL == table_info)) {
                snmp_log(LOG_ERR,
                         "could not extract table entry or info for cpqSePciFunctTable\n");
                snmp_set_var_typed_value(request->requestvb,
                                         SNMP_ERR_GENERR, NULL, 0);
                continue;
            }

            switch (table_info->colnum) {
            case COLUMN_CPQSEPCIFUNCTBUSNUMBERINDEX:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_integer(request->requestvb, ASN_INTEGER,
                                           table_entry->
                                           cpqSePciFunctBusNumberIndex);
                break;
            case COLUMN_CPQSEPCIFUNCTDEVICENUMBERINDEX:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_integer(request->requestvb, ASN_INTEGER,
                                           table_entry->
                                           cpqSePciFunctDeviceNumberIndex);
                break;
            case COLUMN_CPQSEPCIFUNCTINDEX:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_integer(request->requestvb, ASN_INTEGER,
                                           table_entry->
                                           cpqSePciFunctIndex);
                break;
            case COLUMN_CPQSEPCIFUNCTCLASSCODE:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_value(request->requestvb, ASN_OCTET_STR,
                                         table_entry->
                                         cpqSePciFunctClassCode,
                                         table_entry->
                                         cpqSePciFunctClassCode_len);
                break;
            case COLUMN_CPQSEPCIFUNCTCLASSDESCRIPTION:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_value(request->requestvb, ASN_OCTET_STR,
                                         table_entry->
                                         cpqSePciFunctClassDescription,
                                         table_entry->
                                         cpqSePciFunctClassDescription_len);
                break;
            case COLUMN_CPQSEPCIFUNCTDEVICEID:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_integer(request->requestvb, ASN_INTEGER,
                                           table_entry->
                                           cpqSePciFunctDeviceID);
                break;
            case COLUMN_CPQSEPCIFUNCTVENDORID:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_integer(request->requestvb, ASN_INTEGER,
                                           table_entry->
                                           cpqSePciFunctVendorID);
                break;
            case COLUMN_CPQSEPCIFUNCTREVID:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_integer(request->requestvb, ASN_INTEGER,
                                           table_entry->
                                           cpqSePciFunctRevID);
                break;
            case COLUMN_CPQSEPCIFUNCTINTLINE:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_integer(request->requestvb, ASN_INTEGER,
                                           table_entry->
                                           cpqSePciFunctIntLine);
                break;
            case COLUMN_CPQSEPCIFUNCTDEVSTATUS:
                if (!table_entry) {
                    netsnmp_set_request_error(reqinfo, request,
                                              SNMP_NOSUCHINSTANCE);
                    continue;
                }
                snmp_set_var_typed_integer(request->requestvb, ASN_INTEGER,
                                           table_entry->
                                           cpqSePciFunctDevStatus);
                break;
            default:
                netsnmp_set_request_error(reqinfo, request,
                                          SNMP_NOSUCHOBJECT);
                break;
            }
        }
        break;

    }
    return SNMP_ERR_NOERROR;
}

/**
 * @internal
 */
static int
_cache_load(netsnmp_cache * cache, void *vmagic)
{
    netsnmp_container *container;

    DEBUGMSGTL(("internal:cpqSePciFunctTable:_cache_load", "called\n"));

    if ((NULL == cache) || (NULL == cache->magic)) {
        snmp_log(LOG_ERR,
                 "invalid cache for cpqSePciFunctTable_cache_load\n");
        return -1;
    }
    container = (netsnmp_container *) cache->magic;

    /** should only be called for an invalid or expired cache */
    netsnmp_assert((0 == cache->valid) || (1 == cache->expired));

    /*
     * load cache here (or call function to do it)
     */
    netsnmp_arch_pcifunc_container_load(container);
    return 0;
}                               /* _cache_load */

/**
 * @Internal
 */
/** remove a row from the table */
static void
cpqSePciFunctTable_freeEntry_cb(cpqSePciFunctTable_entry * entry,
                                void *magic)
{

    cpqSePciFunctTable_freeEntry(entry);
}

/**
 * @internal
 */
static void
_cache_free(netsnmp_cache * cache, void *magic)
{
    netsnmp_container *container;

    DEBUGMSGTL(("internal:cpqSePciFunctTable:_cache_free", "called\n"));

    if ((NULL == cache) || (NULL == cache->magic)) {
        snmp_log(LOG_ERR,
                 "invalid cache in cpqSePciFunctTable_cache_free\n");
        return;
    }
    container = (netsnmp_container *) cache->magic;

    /*
     * empty (but don't free) cache here
     */
    CONTAINER_CLEAR(container,
                    (netsnmp_container_obj_func *)
                    cpqSePciFunctTable_freeEntry_cb, NULL);
}                               /* _cache_free */
